package com.muyu.marketing.domain.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.muyu.marketing.domain.ActivityTeamInfo;
import com.muyu.marketing.domain.resp.ActivityTeamProjectSkuResp;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.Date;
import java.util.List;

@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamInfoByIdQueryModel {
    /**
     * 拼团ID
     */
    private Long teamId;

    /**
     * 拼团名称
     */
    private String name;
    /**
     * 商品ID
     */
    private Long productId;

    /**
     * 商品名称
     */
    private String produceName;
    /**
     * 商品活动图
     */
    private String productImage;
    /**
     * 活动简介
     */
    private String introduction;
    /**
     * 单位 temoteproduyce
     */

    private String unit;
    /**
     * 轮播图
     */
    private String imageList;

    /**
     * 商品SkU集合
     */
    private List<ActivityTeamProjectSkuResp> activityTeamProjectSkuList;

    /**
     * 活动结束时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd")
    private Date endTime;
    /**
     * 活动排序
     */
    private Integer sort;
    /**
     * 活动详情
     */
    private String content;
    /**
     * 活动状态
     */
    private String status;
    /**
     * 策略类型
     */
    private String strategyType;
    /**
     * 策略ID
     */
    private Long strategyId;


    public static ActivityTeamInfoByIdQueryModel FindByIdQuery(ActivityTeamInfo activityTeamInfo,String name,List<ActivityTeamProjectSkuResp> activityTeamProjectSkuList){
        return ActivityTeamInfoByIdQueryModel.builder()
                .teamId(activityTeamInfo.getId())
                .name(activityTeamInfo.getName())
                .productId(activityTeamInfo.getProductId())
                .produceName(name)
                .productImage(activityTeamInfo.getProductImage())
                .introduction(activityTeamInfo.getIntroduction())
                .unit(activityTeamInfo.getUnit())
                .imageList(activityTeamInfo.getImageList())
                .activityTeamProjectSkuList(activityTeamProjectSkuList)
                .endTime(activityTeamInfo.getEndTime())
                .sort((int) activityTeamInfo.getSort())
                .content(activityTeamInfo.getContent())
                .status(activityTeamInfo.getStatus())
                .strategyType(activityTeamInfo.getStrategyType())
                .strategyId(activityTeamInfo.getStrategyId())
                .build();
    }
}
