package com.muyu.marketing.domain.resp;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.muyu.marketing.domain.model.ActivityTeamInfoByIdQueryModel;
import com.muyu.marketing.domain.req.TeamProjectSkuInfoAddReq;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.Date;
import java.util.List;

@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamDetailResp {
    /**
     * 拼团ID
     */
    private Long teamId;

    /**
     * 拼团名称
     */
    private String name;
    /**
     * 商品ID
     */
    private Long productId;

    /**
     * 商品名称
     */
    private String productName;
    /**
     * 商品活动图
     */
    private String productImage;
    /**
     * 活动简介
     */
    private String introduction;
    /**
     * 单位 temoteproduyce
     */

    private String unit;
    /**
     * 轮播图
     */

    private String imageList;
    /**
     * 活动结束时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd")
    private Date endTime;
    /**
     * 活动排序
     */
    private Integer sort;
    /**
     * 商品SkU集合
     */
    private List<ActivityTeamProjectSkuResp> activityTeamProjectSkuList;
    /**
     * 活动详情
     */
    private String content;
    /**
     * 活动状态
     */
    private String status;
    /**
     * 策略类型
     */
    private String strategyType;
    /**
     * 策略ID
     */
    private Long strategyId;

    public static  ActivityTeamDetailResp findByTeamId(ActivityTeamInfoByIdQueryModel activityTeamInfoByIdQueryModel){
        return ActivityTeamDetailResp.builder()
                .teamId(activityTeamInfoByIdQueryModel.getTeamId())
                .name(activityTeamInfoByIdQueryModel.getName())
                .productId(activityTeamInfoByIdQueryModel.getProductId())
                .productName(activityTeamInfoByIdQueryModel.getProduceName())
                .productImage(activityTeamInfoByIdQueryModel.getProductImage())
                .introduction(activityTeamInfoByIdQueryModel.getIntroduction())
                .unit(activityTeamInfoByIdQueryModel.getUnit())
                .imageList(activityTeamInfoByIdQueryModel.getImageList())
                .activityTeamProjectSkuList(activityTeamInfoByIdQueryModel.getActivityTeamProjectSkuList())
                .endTime(activityTeamInfoByIdQueryModel.getEndTime())
                .sort(activityTeamInfoByIdQueryModel.getSort())
                .content(activityTeamInfoByIdQueryModel.getContent())
                .status(activityTeamInfoByIdQueryModel.getStatus())
                .strategyType(activityTeamInfoByIdQueryModel.getStrategyType())
                .strategyId(activityTeamInfoByIdQueryModel.getStrategyId())
                .build();
    }
}
