package com.muyu.marketing.domain.resp;

import com.muyu.marketing.domain.model.ActivityTeamProductSKUModel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.math.BigDecimal;

@Data
@NoArgsConstructor
@AllArgsConstructor
@SuperBuilder
public class ActivityTeamProjectSkuResp {
    /**
     * 团购商品Sku的ID
     */
    private Long productSkuId;

    /**
     * 规格SKu
     */
    private String  sku;

    /**
     * 拼团价格
     */
    private BigDecimal teamPrice;

    /**
     * 拼团库存
     */
    private Long teamStock;

    public static ActivityTeamProjectSkuResp getById(ActivityTeamProductSKUModel activityTeamProductSKUModel){
        return ActivityTeamProjectSkuResp.builder()
                .productSkuId(activityTeamProductSKUModel.getProductId())
                .sku(activityTeamProductSKUModel.getSku())
                .teamPrice(activityTeamProductSKUModel.getTeamPrice())
                .teamStock(activityTeamProductSKUModel.getTeamStock())
                .build();
    }
}
